//////////////////////////////////////////////////////////////////////////
//                                                                      //
// acosf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

//      acos

//      /   
//  (    )
static unsigned int _DKDK[13] ={	0x36C7395E,	0x2D8E72BD,	0x2B616F29,	0x2AD83913,	0x2AB60C1A,	0x2AAD82E4,
			 0x2AAB60B7,	0x2AAAD82E,	0x2AAAB60B,	0x2AAAAD83,	0x2AAAAB61,	0x2AAAAAD8,	0x2AAAAAB6};

//        float,
//      
static unsigned int _DDKDK[13] = {0x3FDB1CE5,	0x3FB639CB,	0x3FAD85BD,	0x3FAB60E4,	0x3FAAD830,	0x3FAAB60C,
				0x3FAAAD83,	0x3FAAAB61,	0x3FAAAAD8,	0x3FAAAAB6,	0x3FAAAAAE,	0x3FAAAAAB,	0x3FAAAAAB};

//   
//  iTBL[i] = atan(1./pow(2,i)) * (1 << i) * 0x40000000
extern int _iTBL[42];

#ifdef __cplusplus
extern "C" {
#endif

// acosf --
//
//    
//
//    --.
//    CORDIC,    .

float acosf (float f){
	int Mnt;                    //   
    int x, y;                   //    
    int t;                      //       
    int XKK;                    //    * 
    int atan;                   //      
	int Exp, Sgn, Spc;          //  ,     
	int NewExp;                 //   
	int i;                      //     
    int j;                      //  ,    
	int rez = 0;                //   
	int iMj, iPj;               //      i-j, i+j

    //   float
	DestructFloat( f, Mnt, Exp, Sgn, Spc );

	//  
	if ( !Exp && Mnt == 0x00800000  )	// +-1:  pi, 0	
		if (Sgn)
			return ConstructFloat( 0x00c90fdb, 1, 0, 0);
		else
			return ConstructFloat( 0, -127, 0, 0);

	if ( Exp >-1  ){	// |x|>1 :  NAN
		_FPIEEE_Signal( _FPIEEE_Invalid ); 
		return ConstructFloat( 1, 128, 0, 0);
	}

	if ( Exp < -26 )			//    
		return ConstructFloat( 0x00c90fdb, 0, 0, 0);

	x = 0;
	y = 0;
	NewExp = 0;
	j=0;
    //      ( )
	if (Exp<-1 || Mnt<0x008a5140)
		j=0;
	else if (Mnt<0x00e0a940)
		j=1;
	else if (Mnt<0x00f80aa5)
		j=2;
	else if (Mnt<0x00fe00ab)
		j=3;
	else if (Mnt<0x00ff800b)
		j=4;
	else if (Mnt<0x00ffe001)
		j=5;
	else if (Mnt<0x00fff800)
		j=6;
	else if (Mnt<0x00fffe00)
		j=7;
	else if (Mnt<0x00ffff80)
		j=8;
	else if (Mnt<0x00ffffe0)
		j=9;
	else if (Mnt<0x00fffff8)
		j=10;
	else if (Mnt<0x00fffffe)
		j=11;
	else  
		j=12;

	i=j;

        //      
	if (Exp<-6)
		Mnt>>= -Exp-6;
	else
		Mnt<<= Exp+6;
	int Uno = 0x20000000;
		//      . 
	int TMP = int(float(0x20000000-Mnt) * (*(float*)&_DDKDK[j]));
	XKK = -(_DKDK[j]) + 
		((0x20000000-Mnt)<<(j<<1)) +
		TMP;

    //    CORDIC,    .
	while (i-j<32){

		iMj = i - j;
		atan = _iTBL[i]>>iMj;
		iPj = i + j;

		t = x;						//  
		if ( (x>XKK) == (y>=0) ){
			x -= y>>iMj;		//  
			y -= Uno;
			y += t>>iPj;
			rez -= atan;
		}
		else{
			x += y>>iMj;		//  
			y += Uno;
			y -= t>>iPj;
			rez += atan;
		}
		t = x;						//  
		if ( (x>XKK) == (y>=0) ){
			x -= y>>iMj;		//  
			y -= Uno;
			y += t>>iPj;
			rez -= atan;
		}
		else{
			x += y>>iMj;		//  
			y += Uno;
			y -= t>>iPj;
			rez += atan;
		}
		i++;
		Uno >>=1;
	}
    //      
	NewExp = -j+1;
	if (Sgn){
        //  acos(-x) = Pi - acos(x)
		while(NewExp<1){
			NewExp++;
			rez>>=1;
		}
		rez = 0x6487ed51 - rez;
	}
    //      
	if (rez!=0){
		while (!(rez & 0x40000000)){
			rez <<= 1;
			NewExp--;
		}
	}
	else
		NewExp = -127;

    //     , ...  
	rez >>=6;
	//    ,  .
	rez = (rez>>1) + (rez & 1);
	if (rez == 0x01000000){	
		rez = 0;
		NewExp++;
	}
    //   float
	return ConstructFloat( rez, NewExp, 0, 0);		
}

#ifdef __cplusplus
}
#endif
