/*
 *	Copyright (c) 1993-1996 by Research Computer Center (Expert Team)
 *	Moscow State University, Moscow, Russia
 *	All rights reserved.
 *
 *	%W%     %E%     (c) SRCC
 */

#include <assert.h>

/*------------------------------------------------------\
|							|
|	Array Iterator					|
|							|
\------------------------------------------------------*/

#ifdef DEBUG
#include <stdio.h>
#endif

#include <new-align.h>

typedef void (*CTOR)(char*);

extern int _ThrowTypesCnt;

extern "C" void
_ArrayCtorIterator(char *mass, int size, int size_elem, CTOR fun, CTOR dtor)
{
	char *pnt;
	long i;
	int *counter = (int*)mass;
	int was_except = _ThrowTypesCnt;

	assert (size>=0);

	*counter = 0;
	pnt = mass + sizeof(int)*NEW_ALIGN;

#ifdef DEBUG
	printf ("ArrayCtorIterator (%p, size = %d, size_elem=%d, CTOR=%p, "
		"DTOR=%p)\n", mass, size, size_elem, fun, dtor);
#endif

	if (fun != 0) {
		for (i=1; i<=size; i++) {
			if (was_except)
				fun (pnt);
			else {
				try {
					fun (pnt);
				} catch (...) {

#ifdef DEBUG
					printf ("EXCEPTION in ArrayCtorIter!\n");
#endif
					/* exception succeded in the ctor */
					pnt -= size_elem;

					while (pnt >=
						mass+sizeof(int)*NEW_ALIGN) {

						if (dtor)
							dtor (pnt);

						pnt -= size_elem;
					};

					throw;
				}
			};

			(*counter)++;
			pnt += size_elem;
		}
	};
}

extern "C" void
_ArrayDtorIterator (int *mass, int size_elem, CTOR fun)
{
	int size = *mass;
	char *pnt;
	long i;

	mass += NEW_ALIGN;

	pnt = ((char*)mass) + (size-1)*size_elem;

#ifdef DEBUG
	printf (
		"ArrayDtorIterator (%p, %d, %p): size = %d\n", mass,
		size_elem, fun, size
	);
#endif

	for (i=size-1; i>=0; i--) {
		fun (pnt);
		pnt -= size_elem;
	}
}
