//////////////////////////////////////////////////////////////////////////
//                                                                      //
//               NeuroMatrix(r) C runtime library                       //
//                                                                      //
//  memcmp.c                                                            //
//                                                                      //
// Copyright (c) 1997-2008 RC Module                                    //
//  If this code works, it was written by Alex Ruzavin                  //
//  If not, I don't know who wrote it.                                  //
//                                                                      //
// $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                  //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif  // __cplusplus

#if !defined(__NM6403__) && !defined(__NM6405__)

int memcmp( const void * str1, const void * str2, size_t count)
{
  register unsigned char *s1 = (unsigned char*)str1;
  register unsigned char *s2 = (unsigned char*)str2;

  while (count-- > 0)
    {
      if (*s1++ != *s2++)
	  return s1[-1] < s2[-1] ? -1 : 1;
    }
  return 0;
}

#else	//	 char[]-   ,  int-,   .

int memcmp( const void * str1, const void * str2, size_t count)
{
  int *s1 = (int*)str1;
  int *s2 = (int*)str2;

  while (count-- > 0)
    {
      if (*s1++ != *s2++)
	  return s1[-1] < s2[-1] ? -1 : 1;
    }
  return 0;
}

#endif  // !defined(__NM6403__) && !defined(__NM6405__)
