//----------------------------------------------------------------------//
//                                                                      //
//                     Neuroprocessor NM6403 SDK v. 1.20                //
//                                                                      //
//                              Demo program                            //
//             that exchange arrays with NM6403 on board.               //
//                         PC part of program.                          //
//                                                                      //
//                 1998 (c) RC Module Inc., Moscow, Russia              //
//                                                                      //
//----------------------------------------------------------------------//

#include <conio.h>

#include <iostream>
#include <stdlib.h>
#include "pciload.h"

using namespace std;

const char * Name = "nmpart.abs";
int main()
{
    PL_Board  *board;
    PL_Access *access;
    int boardCount;

    if ( PL_GetBoardCount( &boardCount ) ) {
        cout << "ERROR: Can't open driver.\n";
        exit(1);
    }

    if ( boardCount < 1 ) {
        cout << "ERROR: Can't find board.\n";
        exit(1);
    }

    if ( PL_GetBoardDesc( 0, &board ) ) {
        cout << "ERROR: Can't open board " << 0 << ".\n";
        exit(1);
    }

    if ( PL_ResetBoard( board ) ) {
        cout << "ERROR: Can't reset board " << 0 << ".\n";
        exit(1);
    }

    if ( PL_LoadInitCode( board ) ) {
        cout << "ERROR: Can't load init code on board " << 0 << ".\n";
        exit(1);
    }

    if ( PL_GetAccess( board, 1, &access ) ) {
        cout << "ERROR: Can't access processor " << 1 << " on board " << 0 << ".\n";
        exit(1);
    }

  //  if ( PL_LoadProgramFile( access, Name ) ) {
    //    cout << Name << ": : ERROR: Can't load program into board.\n";
    //    exit(1);
   // }


  //  PL_Light( board, 1 );
    //getch();

    //PL_Light( board, 0 );
    //getch();

    int code = 0;
    PL_Word Length = 0;
    PL_Word * Buffer = 0;
    PL_Word AddrLoad = 0;
    PL_Word AddrStore = 0;
    int syncValue = 0;

        // receive input array address.
    if ( PL_SyncArray( access, 0, NULL, NULL, &syncValue, &AddrLoad, &Length ) != PL_OK ) {
        cout << "error in sync 1\n";
        return 2;
    }
    if ( syncValue != 1 ) {
        cout << "error value in sync 1\n";
        return 2;
    }

    Buffer = new PL_Word[ Length ];

    int light = 0;

    for ( PL_Word j = 1; j < 331; j++ ) {

            // sync for receive array and address of output array.
        if ( PL_SyncArray( access, 1, NULL, NULL, &syncValue, &AddrStore, NULL ) != PL_OK ) {
            cout << "error in sync 1\n";
            return 2;
        }
        if ( syncValue != 2 ) {
            cout << "error value in sync 2\n";
            return 3;
        }

            // receive array
        PL_ReadMemBlock( access, Buffer, AddrLoad, Length );
        cout << "Verify number " << j << endl;
        for ( PL_Word i = 0; i < Length; i++ ) {
            if ( Buffer[i] != j ) {
                cout << "bad buffer on step " << j << endl;
                return 4;
            }

                // new fill of array
            Buffer[i] = j+1;
        }

        PL_WriteMemBlock( access, Buffer, AddrStore, Length );

      //  if ( (j & 0xf) == 0 ) {
        //    PL_Light( board, light );
        //    light = ~light;
       // }

            // sync for send array
        if ( PL_Sync( access, 2, &syncValue ) != PL_OK ) {
            cout << "error in sync 2\n";
            return 3;
        }

        if ( syncValue != 3 ) {
            cout << "error value in sync \n";
            return 4;
        }

    }

        // Sync for end program.
    PL_Sync( access, 17, NULL );

	delete Buffer;

    cout << "Test Ok.\n";
    return 0;
}
